#ifndef _TELNET_WINDOW_H
#	define _TELNET_WINDOW_H

#include "TelnetLooper.h"
#include "StatusView.h"

#include <ArpCommon/ArpRemoteTerminal.h>
#include <ArpCommon/ArpEmulatorManager.h>
#include <TCPSockets.h>
#include <interface/Menu.h>
#include <interface/MenuBar.h>
#include <interface/ScrollBar.h>
#include <interface/Window.h>
#include <storage/File.h>

class TelnetWindow:
	public BWindow {
protected:
	ArpRemoteTerminal *output_dev;
	BFile *save_file;
	BMenuBar *menu_bar;
	BMenu *edit_menu, *emulation_menu;
	BScrollBar *horiz_scroll, *vert_scroll;
	StatusView *stat_view;
	char *hostname, *portname;

	// Preferences.
	rgb_color fore_color, back_color;

	// Socket information.
	TCPLooper *io_looper;

	// The add-on emulator manager for ArpTerminal
	ArpEmulatorManager manager;

	void AddMenuBar(BRect frame);
	void ResizeToTerm(int32 rows=-1, int32 cols=-1);

public:
	TelnetWindow(BRect frame, const char *name, const char *port);

	virtual	bool QuitRequested();
	virtual void MessageReceived(BMessage *msg);

	virtual void SendRemote(const char *stream, int32 nbytes);

	virtual void SaveAsWindow();
	virtual void SaveIntoFile(BFile *file);
	virtual void SetSaveFile(entry_ref *ref);
};

#endif
